const low = require("lowdb")
const FileSync = require("lowdb/adapters/FileSync")

function Read(files, get, filterName) {

    const adapter = new FileSync(files)
    const db = low(adapter)

    if(files && !get || get && !filterName) {
        const bdd = db.get()
        const data = Object.values(bdd)

        return data[0]
    }

    if(typeof filterName !== "object") return Error("le filter doit être un object")

    const data = db.get(get).filter(filterName).value()

    if(data[0] === undefined) return 

    return data[0]

}
//console.log(Read("test.json", "Carte", {name: "Kms"}))

function find(files, get, filterName) {

    const adapter = new FileSync(files)
    const db = low(adapter)

    if(typeof filterName !== "object") return Error("le finder doit être un object")

    const data = db.get(get).find(filterName).value()

    if(data === undefined) return

    return data

}
//console.log(find("test.json", "inv", {name: "holia"}))
//console.log(find("test.json", "inv", {i: "i"}))

function push(files, get, push) {

    const adapter = new FileSync(files)
    const db = low(adapter)


    const data = db.get(get).push(push).write()

    if(data === undefined) return

    return data   //console.log(Object.values(db)[0].push({inv: []}))
}
//push("test.json", "inv", {UserId: "ftg", ID: 9, name: "mdr"})

function defaut(files, push) {

    const adapter = new FileSync(files)
    const db = low(adapter)


    const data = db.defaults(push).write()

    if(data === undefined) return 


    return data

}
//defaut("test.json", { test: []})

function assign(files, get, filterName, assign) {
    const adapter = new FileSync(files)
    const db = low(adapter)


    if(typeof filterName !== "object") return Error("le finder doit être un object")
    if(typeof assign !== "object") return Error("le assign doit être un object")

    const data = db.get(get).find(filterName).assign(assign).write()

    //console.log(typeof assign)
    if(data === undefined) return 

    return data

}
//console.log(assign("test.json", "tg", {UserId: "mdr"}, {naame: "test"}))

function deleting(files, get, filterName) {
    const adapter = new FileSync(files)
    const db = low(adapter)

    const data = db.get(get).remove(filterName).write()
}
//deleting("test.json", "test", {name: "test"})


/*setTimeout(() => {
    
}, 99999);*/


module.exports = {

    Read,
    find,
    push,
    defaut,
    assign,
    deleting

}